// HapAXPlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HapAXPlayer.h"
#include "HapAXPlayerDlg.h"
#include "HapDlgYo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

void	g_MyCB(const char* in, const char** out, void* data)
	{
	if (!data)
		return;

	((CHapAXPlayerDlg*)data) ->	MyCB(in, out);
	}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{

public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHapAXPlayerDlg dialog

CHapAXPlayerDlg::CHapAXPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHapAXPlayerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHapAXPlayerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Console	=	NULL;
	m_SocketHandler = NULL;
}

CHapAXPlayerDlg::~CHapAXPlayerDlg()
	{
	if (m_Console)
		delete m_Console;

	}

void CHapAXPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHapAXPlayerDlg)
	DDX_Control(pDX, IDC_ACTIVEHAPTEKXCTRL1, m_HapAX);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHapAXPlayerDlg, CDialog)
	//{{AFX_MSG_MAP(CHapAXPlayerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHapAXPlayerDlg message handlers

BOOL CHapAXPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	::DragAcceptFiles(m_hWnd, FALSE);


	RECT	r1;
	GetClientRect(&r1);
	m_HapAX.SetWindowPos(NULL, 0, 0, r1.right - r1.left, r1.bottom - r1.top, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);

	m_Console	=	new	HapDlgYo;
	m_Console	->	Create(IDD_DLG_YO, this);
	m_Console	->	m_CBSendText		=	&g_MyCB;
	m_Console	->	m_CBQuery			=	&g_MyCB;
	m_Console	->	m_CBDataSendText	=	this;
	m_Console	->	m_CBDataQuery		=	this;

	if (m_StartupFile.IsEmpty())
		{
		m_HapAX.SetHyperText("\\load [file= data/DefaultAXPlayerStartup.hap]");
		}
	else
		{
		char	cmd[1024];

		sprintf(cmd, "\\load [file= [%s]]", m_StartupFile);
		m_HapAX.SetHyperText(cmd);
		}

	// Run DEIRA Socket (wait for a client)
	// NOTE: There is a second call to this function in windowProc below(!)
	initSocket();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHapAXPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHapAXPlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CHapAXPlayerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void	CHapAXPlayerDlg::MyCB(const char* in, const char** out)
	{
	if (!in)
		return;

	if (!out)
		{
		m_HapAX.SetHyperText(in);
		}
	else
		{
		m_HapAX.SetQuery(in);
		m_QueryAnswer	=	m_HapAX.GetQuery();
		*out			=	m_QueryAnswer;
		}
	}


void CHapAXPlayerDlg::OnOK() 
{
	if (!m_Console)
		return;

	m_Console	->	ShowWindow(SW_NORMAL);
	m_Console	->	SetFocus();

}

void CHapAXPlayerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CHapAXPlayerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if (!GetSafeHwnd() || !m_HapAX.GetSafeHwnd())
		return;

	RECT	r1;
	GetClientRect(&r1);
	m_HapAX.SetWindowPos(NULL, 0, 0, r1.right - r1.left, r1.bottom - r1.top, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
}


LRESULT CHapAXPlayerDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	LRESULT	rtn;

	switch(message) {
		case WM_TIMER:
			OnTimer(1);
			rtn =   0;
			break;
		case WM_DROPFILES:
			DoDrop((HDROP)wParam);
			rtn	=	0;
			break;
		default:
			rtn	=	CDialog::WindowProc(message, wParam, lParam);
			break;
	}

	return rtn;
}

void CHapAXPlayerDlg::DoDrop(HDROP hDrop)
	{
	if (!hDrop)
		return;

	int		i, inum;
	char	fn[1024];
	CString	cs;
	CWnd*	pf;
	
	inum	=	DragQueryFile(hDrop, 0xFFFFFFFF, fn, MAX_PATH);

	CFileStatus		cfs;

	for (i = 0; i < inum; i++)
		{
		DragQueryFile(hDrop, i, fn, MAX_PATH);

		// If it's a folder, run \PathAdd on it instead.
		CFile::GetStatus(fn, cfs);

		
		if (cfs.m_attribute & CFile::directory)
			{
			cs	=	"\\PathAdd [name= [";
			cs	+=	fn;
			cs	+=	"]]";
			}
		else
			{
			cs	=	"\\load [file= [";
			cs	+=	fn;
			cs	+=	"]]";
			}

		m_Console			-> m_GUI_Combo1.SetWindowText	(cs);
		pf	=	m_Console	-> m_GUI_Combo1.SetFocus		();
		m_Console			-> OnOK							();
		if (pf && pf -> GetSafeHwnd())
			::SetFocus(pf -> GetSafeHwnd());
		}

	DragFinish(hDrop);
	}

/*************************************************************************
 * Trackside DEIRA Link
 *************************************************************************/
/* NOTE (Almer): Most of this is adapted from the VisageLink Program */

/*
 * One 'interesting' aspect of this code is the handling of sending back DONE
 * commands over the socket. As the communication has been kept VisageLink
 * compatible it basically expects a DONE command for everything except
 * animations that are send on their own (background animations, the headmotion ones).
 * So, the code below only sends back a DONE command if ALL lines on the queue were
 * headmotion commands.
 *
 * Ofcourse there are ample opportunities for this to go wrong (for example if the sending
 * of an event and background animation is really close). Sometimes the commentator can be
 * 3 to 4 lines behind. This is also caused by text not arriving at the socket at the same
 * rate as it has been sent.
 *
 * Ideally a separate control mechanism would be written. Preferably one that also polls
 * the TTS state (speaking) over the protocol from Trackside DEIRA (when it is ready to
 * send a new message). Keeping them on the queue there as needed.
 *
 * Hmmm, well, at least this demos that establishing a connection with HapTek is possible.
 */
void CHapAXPlayerDlg::OnTimer(UINT_PTR nIDEvent) {
	if (m_SocketHandler->hasClient()) { // Client is connected
		// Read all pending lines from client and process them.
		bool hadLines = m_SocketHandler->hasLine();
		while (m_SocketHandler->hasLine()) {
			std::string line = m_SocketHandler->getLine();
			processLine(line);
		}

	} else { /* Remove the timer and wait for new connection */
		KillTimer(1);
		initSocket(); // NOTE: There is also a call to this function in the dialog init function (!)
	}
}

/*
 * NOTE (Almer): This is a highly inelegant timer based solution. Nevertheless it does
 * the job. Basically it just checks if anything is waiting on the socket every timer interval
 * and if so, it pushes it to processLine that handles the actual 'talking'.
 *
 * A real solution would be an event based socket .... but oh well .. time you know :)
 */
void CHapAXPlayerDlg::initSocket() {
	//=-- Open socket connection
	int port = 9999;
	this->m_SocketHandler = new LineSocketServer(port);
	this->m_SocketHandler->setNoDelay(true); // Enable TCP_NODELAY, since we do not immediately send something back in our protocol
	if (!this->m_SocketHandler->waitForClient()) { // Wait for a client to connect
		//CString msg;
		//msg = "Error while waiting for client!";
		//MessageBox(0,msg,"Error",MB_ICONERROR);
		exit(1);
	}

	// Bind a timer, and set it to read the socket contents every 25 msecs.
	// Timer interrupts are handled in windowProc as WM_TIMER (see above)
	SetTimer(1, 25, NULL);
}

void CHapAXPlayerDlg::reinitSocket() {
	this->closeSocket();
	this->initSocket();
}

void CHapAXPlayerDlg::closeSocket() {
	if (this->m_SocketHandler) {
		delete this->m_SocketHandler;
		this->m_SocketHandler = NULL; 
	}
}

bool CHapAXPlayerDlg::processLine(std::string line) 
{
	// Extract Command and command Content
	if (line.size()>4)
	{
		string command = line.substr(1,3);
		string commandContent = line.substr(5);

		if (!command.compare("TTS")) { // TTS Command given
			m_HapAX.SetHyperText(("\\Q2 [s0= [" + commandContent + "] i0=[3]]").c_str());
		
			/* PROBLEM: The Q2 command returns directly ... we actually want to wait
			   a bit till the text has been spoken (!). So we need to query the control
			   periodically (whilst handling window messages as well).
		     */
			int status = 1;
			while (status == 1) {
				/* Keep processing window messages */
				MSG msg;
				while(PeekMessage(&msg,NULL,NULL,NULL,PM_REMOVE)) {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
				Sleep(25);

				m_HapAX.SetQuery("status tts busy");
				status = atoi(m_HapAX.GetQueryReturn());
			}
			this->m_SocketHandler->sendLine("DONE\n");
			return true;
		} else if (!command.compare("HAP")) { // Haptek feeform command given
			
				m_HapAX.SetHyperText((commandContent).c_str());
				this->m_SocketHandler->sendLine("DONE\n");
				return true;

		} else if (!command.compare("NAC")) { // Haptek feeform command given, no ack allowed! (for animations)
			
				m_HapAX.SetHyperText((commandContent).c_str());
				return true;
		}

	}
	return true;

}
