#ifndef LINE_SOCKET_H
#define LINE_SOCKET_H

#include <iostream>
#include <fstream>
#include <string>
#include <queue>

#include <winsock2.h>

class LineSocket {
private:
	SOCKET targetSocket;
	bool noDelay;

	char buffer[1024];
	size_t bufferOffset;
	std::string line;
	std::queue<std::string>* lines;

	bool parseBuffer();
	bool fillBuffer();
protected:
	std::ostream* debugStream;

	bool hasTargetSocket();
	SOCKET getTargetSocket();
	void setTargetSocket(SOCKET targetSocket);
public:
	LineSocket();
	~LineSocket();

	bool hasLine();
	std::string getLine();
	bool sendLine(std::string line);

	void setNoDelay(bool noDelay);
};

#endif