// SimpleFacialExpression.cpp: implementation of the SimpleFacialExpression class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SimpleFacialExpression.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SimpleFacialExpression::SimpleFacialExpression(char *expressionName, long expressionDuration, float expressionIntensity)
{
	fbaps = new FBAPs();
	expFbaps = new FBAPs();
	currentExpression = 0;
	maxIntensity = expressionIntensity;

	if(!_strnicmp(expressionName,"anger",strlen(expressionName)))
	{
		expFbaps->setFAP(open_jaw,0);
		expFbaps->setFAP(lower_t_midlip,-90);
		expFbaps->setFAP(raise_b_midlip,66);
		expFbaps->setFAP(stretch_l_cornerlip,13);
		expFbaps->setFAP(stretch_r_cornerlip,13);
		expFbaps->setFAP(lower_t_lip_lm,-90);
		expFbaps->setFAP(lower_t_lip_rm,-90);
		expFbaps->setFAP(raise_b_lip_lm,66);
		expFbaps->setFAP(raise_b_lip_rm,66);
		expFbaps->setFAP(raise_l_cornerlip,-90);
		expFbaps->setFAP(raise_r_cornerlip,-90);

		expFbaps->setFAP(close_t_l_eyelid,200);
		expFbaps->setFAP(close_t_r_eyelid,200);
		expFbaps->setFAP(close_b_l_eyelid,150);
		expFbaps->setFAP(close_b_r_eyelid,150);

		expFbaps->setFAP(raise_l_i_eyebrow,-119);
		expFbaps->setFAP(raise_r_i_eyebrow,-119);
		expFbaps->setFAP(raise_l_m_eyebrow,-60);
		expFbaps->setFAP(raise_r_m_eyebrow,-60);
		expFbaps->setFAP(raise_l_o_eyebrow,47);
		expFbaps->setFAP(raise_r_o_eyebrow,47);
		expFbaps->setFAP(squeeze_l_eyebrow,118);
		expFbaps->setFAP(squeeze_r_eyebrow,119);
	}
	if(!_strnicmp(expressionName,"sadness",strlen(expressionName)))
	{
		expFbaps->setFAP(open_jaw,0);
		expFbaps->setFAP(lower_t_midlip,-90);
		expFbaps->setFAP(raise_b_midlip,-153);
		expFbaps->setFAP(stretch_l_cornerlip,110);
		expFbaps->setFAP(stretch_r_cornerlip,110);
		expFbaps->setFAP(lower_t_lip_lm,-122);
		expFbaps->setFAP(lower_t_lip_rm,-122);
		expFbaps->setFAP(raise_b_lip_lm,-242);
		expFbaps->setFAP(raise_b_lip_rm,-242);
		expFbaps->setFAP(raise_l_cornerlip,-122);
		expFbaps->setFAP(raise_r_cornerlip,-122);

		expFbaps->setFAP(raise_l_i_eyebrow,24);
		expFbaps->setFAP(raise_r_i_eyebrow,24);
		expFbaps->setFAP(raise_l_m_eyebrow,-12);
		expFbaps->setFAP(raise_r_m_eyebrow,-12);
		expFbaps->setFAP(raise_l_o_eyebrow,-60);
		expFbaps->setFAP(raise_r_o_eyebrow,-60);
		expFbaps->setFAP(squeeze_l_eyebrow,144);
		expFbaps->setFAP(squeeze_r_eyebrow,144);
	}
	if(!_strnicmp(expressionName,"joy",strlen(expressionName)))
	{
		expFbaps->setFAP(open_jaw,120);
		expFbaps->setFAP(lower_t_midlip,-181);
		expFbaps->setFAP(raise_b_midlip,-181);
		expFbaps->setFAP(stretch_l_cornerlip,77);
		expFbaps->setFAP(stretch_r_cornerlip,77);
		expFbaps->setFAP(lower_t_lip_lm,-153);
		expFbaps->setFAP(lower_t_lip_rm,-153);
		expFbaps->setFAP(raise_b_lip_lm,-122);
		expFbaps->setFAP(raise_b_lip_rm,-122);
		expFbaps->setFAP(raise_l_cornerlip,273);
		expFbaps->setFAP(raise_r_cornerlip,273);

		expFbaps->setFAP(close_t_l_eyelid,180);
		expFbaps->setFAP(close_t_r_eyelid,180);
		expFbaps->setFAP(close_b_l_eyelid,100);
		expFbaps->setFAP(close_b_r_eyelid,100);

		expFbaps->setFAP(raise_l_i_eyebrow,24);
		expFbaps->setFAP(raise_r_i_eyebrow,24);
		expFbaps->setFAP(raise_l_m_eyebrow,23);
		expFbaps->setFAP(raise_r_m_eyebrow,23);
		expFbaps->setFAP(raise_l_o_eyebrow,0);
		expFbaps->setFAP(raise_r_o_eyebrow,0);
		expFbaps->setFAP(squeeze_l_eyebrow,63);
		expFbaps->setFAP(squeeze_r_eyebrow,63);
	}
	if(!_strnicmp(expressionName,"fear",strlen(expressionName)))
	{
		expFbaps->setFAP(open_jaw,210);
		expFbaps->setFAP(lower_t_midlip,0);
		expFbaps->setFAP(raise_b_midlip,-200);
		expFbaps->setFAP(stretch_l_cornerlip,-38);
		expFbaps->setFAP(stretch_r_cornerlip,-38);
		expFbaps->setFAP(lower_t_lip_lm,0);
		expFbaps->setFAP(lower_t_lip_rm,0);
		expFbaps->setFAP(raise_b_lip_lm,-150);
		expFbaps->setFAP(raise_b_lip_rm,-150);
		expFbaps->setFAP(raise_l_cornerlip,-21);
		expFbaps->setFAP(raise_r_cornerlip,-21);

		expFbaps->setFAP(close_t_l_eyelid,-100);
		expFbaps->setFAP(close_t_r_eyelid,-100);
		expFbaps->setFAP(close_b_l_eyelid,-100);
		expFbaps->setFAP(close_b_r_eyelid,-100);

		expFbaps->setFAP(raise_l_i_eyebrow,100);
		expFbaps->setFAP(raise_r_i_eyebrow,100);
		expFbaps->setFAP(raise_l_m_eyebrow,80);
		expFbaps->setFAP(raise_r_m_eyebrow,80);
		expFbaps->setFAP(raise_l_o_eyebrow,60);
		expFbaps->setFAP(raise_r_o_eyebrow,60);
		expFbaps->setFAP(squeeze_l_eyebrow,135);
		expFbaps->setFAP(squeeze_r_eyebrow,135);
	}
	if(!_strnicmp(expressionName,"surprise",strlen(expressionName)))
	{
		expFbaps->setFAP(open_jaw,696);
		expFbaps->setFAP(lower_t_midlip,0);
		expFbaps->setFAP(raise_b_midlip,-600);
		expFbaps->setFAP(stretch_l_cornerlip,-38);
		expFbaps->setFAP(stretch_r_cornerlip,-38);
		expFbaps->setFAP(lower_t_lip_lm,0);
		expFbaps->setFAP(lower_t_lip_rm,0);
		expFbaps->setFAP(raise_b_lip_lm,-400);
		expFbaps->setFAP(raise_b_lip_rm,-400);
		expFbaps->setFAP(raise_l_cornerlip,-61);
		expFbaps->setFAP(raise_r_cornerlip,-61);

		expFbaps->setFAP(close_t_l_eyelid,-80);
		expFbaps->setFAP(close_t_r_eyelid,-80);
		expFbaps->setFAP(close_b_l_eyelid,-80);
		expFbaps->setFAP(close_b_r_eyelid,-80);
  
		expFbaps->setFAP(raise_l_i_eyebrow,214);
		expFbaps->setFAP(raise_r_i_eyebrow,214);
		expFbaps->setFAP(raise_l_m_eyebrow,178);
		expFbaps->setFAP(raise_r_m_eyebrow,178);
		expFbaps->setFAP(raise_l_o_eyebrow,83);
		expFbaps->setFAP(raise_r_o_eyebrow,83);
		expFbaps->setFAP(squeeze_l_eyebrow,135);
		expFbaps->setFAP(squeeze_r_eyebrow,135);
	}

	// copy outer lip contour from inner lip contour
	for(int i = 0;i<10;i++)
		expFbaps->setFAP(lower_t_midlip_o + i,expFbaps->faps->llf.value[lower_t_midlip + i]);

	duration = expressionDuration;
	if(duration<0)
		duration=0;
	playing = 0;
}
/*
SimpleFacialExpression::setFBAPs(FBAPs *_fbaps,char *mask, char *fapsVal)
{
	FAPs *faps = _fbaps->faps;
	LLFAPs *llfaps = &faps->llf;
	int i;
	
	char *s;
	
	for(i=0; i<N_FAP_GROUP; i++) 
	{
		faps->maskType[i] = 1;
	}
	s = mask;
	for(i=0; i<NFAP; i++) 
	{
		sscanf(s, "%d", &faps->groupMask[i]);	
		while(s[0] && s[0] != ' ') s++;
		s++;
	}
		  
	s = fapsVal;
	for(i=2; i<NFAP; i++) 
	{
		if(faps->groupMask[i]) 
		{
			sscanf(s, "%d", &(llfaps->value[i]));
			while(s[0] && s[0] != ' ') s++;
			s++;
		}
		else
			llfaps->value[i] = 0; 
	}
}
*/
SimpleFacialExpression::~SimpleFacialExpression()
{
	delete fbaps;
}

FBAPs * SimpleFacialExpression::getFBAPs(long globalTime, FBAPs *lastFBAPs, AFM *afm)
{
	if(!playing)
		return fbaps;

	long localTime = globalTime - globalStartTime;

	if(localTime > duration)
		return NULL; // indicate that the action has finished, the FAPlayer may now remove or delete it, depending on the playing mode

	long time_step;
	float intensity_step;
	int phase;
	float dir;

	// calculate the time sice the last call to this function
	time_step = localTime - lastTimeMs;
	lastTimeMs = localTime;

	// check in which phase is the expression
	if(localTime < attack_time) phase = 1; // attack phase
	else
		if(localTime < attack_time+sustain_time) phase = 2; // sustain phase
		else
			phase = 3; // decay phase

	switch(phase)
	{
	case 1: // in the attack phase, grow linearly
		intensity_step = (float)(1.0f * (time_step / attack_time));
		dir = 1.0;
		break;
	case 2: // in the sustain phase, no change
		intensity_step = 0.0;
		dir = 0.0;
		break;
	case 3: // in the decay phase, fall linearly
		intensity_step = (float)(1.0f * (time_step / decay_time));
		dir = -1.0;
		break;
	default:
		intensity_step = 0.0;
		dir = 0.0;
		break;
	}
	// set the intensity for FAP expression 1
	intensity += intensity_step * dir;
	if(intensity>1.0) intensity = 1.0;
	if(intensity<0.0) intensity = 0.0;
	fbaps->set(expFbaps,intensity*maxIntensity);

	return fbaps;
}

void SimpleFacialExpression::start(long globalTime)
{
	globalStartTime = globalTime;
	lastTimeMs = 0;
	attack_time = duration / 6; // the duration of the attack phase, in milliseconds (1/6 of the total duration)
	sustain_time = duration / 2; // the duration of the sustain phase, in milliseconds (3/6 of the total duration)
	decay_time = duration / 3; // the duration of the decay phase, in milliseconds (2/6 of the total duration)
	fbaps->faps->fap2.expression1 = currentExpression;
	fbaps->faps->fap2.intensity1 = 0;
	intensity = 0.0f;
	playing = 1;
}

void SimpleFacialExpression::stop()
{
	fbaps->faps->fap2.expression1 = currentExpression;
	fbaps->faps->fap2.intensity1 = 0;
	playing = 0;
}
